import { InferServiceErrors, InferServiceID, ServiceInterface } from './service-interface';
export declare class ServiceError<T extends Record<string, any> = Record<string, any>> extends Error {
    readonly serviceId: string;
    readonly errorId: string;
    readonly payloads?: T;
    readonly innerError?: Error;
    constructor(options: {
        serviceId: string;
        errorId: string;
        payloads?: T;
        inner?: Error;
    });
    is<K extends ServiceInterface>(options: {
        serviceId?: InferServiceID<K>;
        errorId?: keyof InferServiceErrors<K>;
        payloads?: T;
    }): boolean;
    equals(obj: unknown): boolean;
}
//# sourceMappingURL=error.d.ts.map