import { Collection } from 'mongodb';
export interface CronSessionStorage {
    open(key: string): Promise<[time: number]>;
    close(key: string, time?: number): Promise<void>;
}
export declare class MemoryCronSessionStorage implements CronSessionStorage {
    _times: {
        [key: string]: number;
    };
    _opening: {
        [key: string]: boolean;
    };
    open(key: string): Promise<[time: number]>;
    close(key: string, time?: number): Promise<void>;
}
interface MongoDoc {
    _id: string;
    time: number;
    open?: boolean;
}
export declare class MongoCronSessionStorage implements CronSessionStorage {
    collection: Collection<MongoDoc>;
    constructor(collection: Collection);
    open(serviceId: string): Promise<[time: number]>;
    close(serviceId: string, time?: number): Promise<void>;
}
export {};
//# sourceMappingURL=storage.d.ts.map