export declare type EntityComponent<T_ID, T_Value> = {
    id: T_ID;
} & T_Value;
interface Events<TID, TValue> {
    SETTED: {
        id: TID;
        value: TValue | null;
        time: number;
    };
}
interface Errors<_TID, TValue> {
    LOOKUP_NON_INDEXED_FIELD: {
        field: keyof TValue;
    };
}
interface Functions<TID, TValue> {
    get(id: TID): Promise<EntityComponent<TID, TValue> | undefined>;
    getByIds(ids: TID[]): Promise<(EntityComponent<TID, TValue> | undefined)[]>;
}
export declare type EntityComponentServiceSurface<TID, TValue> = {
    events: Events<TID, TValue>;
    errors: Errors<TID, TValue>;
    functions: Functions<TID, TValue>;
};
export {};
//# sourceMappingURL=entity-component-manager.d.ts.map