export declare type EntityComponent<TValue> = {
    id: string;
    value?: TValue;
};
interface Events<TValue> {
    SETTED: {
        id: string;
        value: TValue | undefined;
        time: number;
    };
}
interface Errors<TValue> {
    LOOKUP_NON_INDEXED_FIELD: {
        field: keyof TValue;
    };
    ACCESS_INVALID_ENTITY: {
        id: string;
    };
}
interface Functions<TValue> {
    get(id: string): Promise<EntityComponent<TValue> | undefined>;
    getByIds(ids: string[]): Promise<(EntityComponent<TValue> | undefined)[]>;
}
export declare type EntityComponentManager<TValue> = {
    events: Events<TValue>;
    errors: Errors<TValue>;
    functions: Functions<TValue>;
};
export {};
//# sourceMappingURL=entity-component.d.ts.map